From c1ff5c8e30eeec589aab3bdf92fc4bc59a767d67 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:29 +0000
Subject: [PATCH 7/17] Move code from monitor to model class.


  - All code that was responsible to save data on the database were
  moved to model.py, this made monitor class more cohesive.

---

diff --git a/Vagrantfile b/Vagrantfile
index 41fa18a..617b439 100644
--- a/Vagrantfile
+++ b/Vagrantfile
@@ -29,8 +29,9 @@ Vagrant.configure(2) do |config|
     # https://developer.fedoraproject.org/tools/vagrant/vagrant-nfs.html
     # After enable nfs-server, you will need to start the service.
     core.vm.synced_folder "./", "/home/vagrant/kiskadee", type: "nfs", nfs_udp: false
-    core.vm.network "public_network", ip: ips[:core], 
+    core.vm.network "public_network", ip: ips[:core],
     :bridge => 'virbr0', :dev => 'virbr0'
+    core.vm.network "forwarded_port", guest: 5000, host: 5000
     core.vm.provider "libvirt" do |v|
       v.memory = 2048
     end
diff --git a/kiskadee/model.py b/kiskadee/model.py
index 6aa3233..4e4dff2 100644
--- a/kiskadee/model.py
+++ b/kiskadee/model.py
@@ -3,7 +3,10 @@
 from sqlalchemy.ext.declarative import declarative_base
 from sqlalchemy import Column, Integer, UnicodeText, UniqueConstraint,\
                        Sequence, Unicode, ForeignKey, orm, JSON
+import json
+
 import kiskadee
+from kiskadee.report import CppcheckReport, FlawfinderReport
 
 Base = declarative_base()
 
@@ -27,6 +30,47 @@ class Package(Base):
             UniqueConstraint('name', 'fetcher_id'),
             )
 
+    @staticmethod
+    def save(session, data):
+        homepage = None
+        if ('meta' in data) and ('homepage' in data['meta']):
+            homepage = data['meta']['homepage']
+
+        _package = Package(
+                name=data['name'],
+                homepage=homepage,
+                fetcher_id=data['fetcher_id']
+                )
+        session.add(_package)
+        session.commit()
+        _version = Version(number=data['version'],
+                           package_id=_package.id)
+        session.add(_version)
+        session.commit()
+        return _package
+
+    @staticmethod
+    def update(session, project, data):
+
+        if(project.versions[-1].number == data['version']):
+            return project
+        try:
+            _new_version = Version(
+                    number=data['version'],
+                    project_id=project.id
+                    )
+            project.versions.append(_new_version)
+            session.add(project)
+            session.commit()
+            kiskadee.logger.debug(
+                    "MONITOR: Sending project {}_{}"
+                    "for analysis".format(data['name'], data['version'])
+                    )
+            return project
+        except ValueError:
+            kiskadee.logger.debug("MONITOR: Could not compare versions")
+            return None
+
 
 class Fetcher(Base):
     """kiskadee fetcher abstraction."""
@@ -64,6 +108,23 @@ class Analyzer(Base):
     version = Column(Unicode(255), nullable=True)
     analysis = orm.relationship('Analysis', backref='analyzers')
 
+    @staticmethod
+    def create_analyzers(_session):
+        """Create the analyzers on database.
+
+        The kiskadee analyzers are defined on the section `analyzers` of the
+        kiskadee.conf file. The `_session` argument represents a sqlalchemy
+        session.
+        """
+        list_of_analyzers = dict(kiskadee.config._sections["analyzers"])
+        for _name, _version in list_of_analyzers.items():
+            if not _session.query(Analyzer)\
+                            .filter_by(name = _name, version = _version )\
+                            .first():
+                new_analyzer = kiskadee.model.Analyzer(name = _name,
+                                                       version = _version)
+                _session.add(new_analyzer)
+        _session.commit()
 
 class Analysis(Base):
     """Abstraction of a package analysis."""
@@ -77,10 +138,44 @@ class Analysis(Base):
     report = orm.relationship('Report',
                               uselist=False, back_populates='analysis')
 
+    @staticmethod
+    def save(session, data, analyzer, result, version):
+        _analysis = kiskadee.model.Analysis()
+        try:
+            _analyzer = session.query(kiskadee.model.Analyzer).\
+                    filter_by(name = analyzer).first()
+            _analysis.analyzer_id = _analyzer.id
+            _analysis.version_id = version.id
+            _analysis.raw = json.loads(result)
+            session.add(_analysis)
+            session.commit()
+            dict_analysis = {
+                    'results': _analysis.raw['results'],
+                    'id': _analysis.id
+                }
+            Report.save(session, dict_analysis, data, _analyzer.name)
+            kiskadee.logger.debug(
+                    "MONITOR: Saved analysis done by {} for package: {}-{}"
+                    .format(analyzer, data["name"], data["version"])
+                )
+            return
+        except Exception as err:
+            kiskadee.logger.debug(
+                    "MONITOR: The required analyzer was " +
+                    "not registered in kiskadee"
+                )
+            kiskadee.logger.debug(err)
+            return None
+
 
 class Report(Base):
     """Abstraction of a analysis report."""
 
+    REPORTERS = {
+        'cppcheck': CppcheckReport,
+        'flawfinder': FlawfinderReport
+    }
+
     __tablename__ = 'reports'
     id = Column(Integer,
                 Sequence('reports_id_seq', optional=True), primary_key=True)
@@ -88,20 +183,34 @@ class Report(Base):
     results = Column(JSON)
     analysis = orm.relationship('Analysis', back_populates='report')
 
+    @staticmethod
+    def save(session, analysis, data, analyzer_name):
+        try:
+            results = analysis['results']
+            analyzer_report = Report.REPORTERS[analyzer_name](results)
+            _reports = Report()
+            _reports.results = json.dumps(
+                    analyzer_report
+                    ._compute_reports(analyzer_name)
+                )
+            _reports.analysis_id = analysis['id']
+            session.add(_reports)
+            session.commit()
+            kiskadee.logger.debug(
+                    "MONITOR: Saved analysis reports for {} package"
+                    .format(data["name"])
+                )
+        except KeyError as key:
+            kiskadee.logger.debug(
+                    "ERROR: There's no reporter " +
+                    "to get reports from {} analyzer. ".format(key) +
+                    "Make shure to import or implement them."
+                )
+        except Exception as err:
+            kiskadee.logger.debug(
+                    "MONITOR: Failed to get analysis reports to {} package"
+                    .format(data["name"])
+                )
+            kiskadee.logger.debug(err)
+        return
 
-def create_analyzers(_session):
-    """Create the analyzers on database.
-
-    The kiskadee analyzers are defined on the section `analyzers` of the
-    kiskadee.conf file. The `_session` argument represents a sqlalchemy
-    session.
-    """
-    list_of_analyzers = dict(kiskadee.config._sections["analyzers"])
-    for name, version in list_of_analyzers.items():
-        if not (_session.query(Analyzer).filter(Analyzer.name == name).
-                filter(Analyzer.version == version).first()):
-            new_analyzer = kiskadee.model.Analyzer()
-            new_analyzer.name = name
-            new_analyzer.version = version
-            _session.add(new_analyzer)
-    _session.commit()
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index ef3fb77..20afeef 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -7,22 +7,15 @@ import threading
 from multiprocessing import Process
 import time
 import os
-import json
 import importlib
 
 import kiskadee.database
-from kiskadee.report import CppcheckReport, FlawfinderReport
 from kiskadee.runner import Runner
 import kiskadee.queue
-from kiskadee.model import Package, Fetcher, Version, Report
+from kiskadee.model import Package, Fetcher, Version, Report, Analysis
 
 RUNNING = True
 
-REPORTERS = {
-    'cppcheck': CppcheckReport,
-    'flawfinder': FlawfinderReport
-}
-
 class Monitor:
     """Provide kiskadee monitoring objects."""
 
@@ -51,163 +44,42 @@ class Monitor:
             pkg = self.kiskadee_queue.dequeue_project()
 
             if pkg:
-                self._send_to_runner(pkg)
+                self.send_to_runner(pkg)
             time.sleep(2)
             analyzed_project = self.kiskadee_queue.dequeue_result()
-            self._save_analyzed_project(analyzed_project)
+            self.save_analyzed_project(analyzed_project)
 
-    def _send_to_runner(self, pkg):
-        _name = pkg['fetcher'].split('.')[-1]
+    def send_to_runner(self, data):
+        _name = data['fetcher'].split('.')[-1]
         _fetcher = self._query(Fetcher).filter_by(name = _name).first()
-        _package = (
-                self._query(Package)
-                .filter(Package.name == pkg['name']).first()
-            )
+        _package = self._query(Package).filter_by(name = data['name']).first()
 
         if _fetcher:
-            pkg["fetcher_id"] = _fetcher.id
+            data["fetcher_id"] = _fetcher.id
             if not _package:
                 kiskadee.logger.debug(
                         "MONITOR: Sending package {}_{} "
-                        " for analysis".format(pkg['name'], pkg['version'])
+                        " for analysis".format(data['name'], data['version'])
                 )
-                self.kiskadee_queue.enqueue_analysis(pkg)
+                self.kiskadee_queue.enqueue_analysis(data)
             else:
-                new_version = pkg['version']
+                new_version = data['version']
                 analysed_version = _package.versions[-1].number
-                fetcher = importlib.import_module(pkg['fetcher']).Fetcher()
+                fetcher = importlib.import_module(data['fetcher']).Fetcher()
                 if (fetcher.compare_versions(new_version, analysed_version)):
-                    self.kiskadee_queue.enqueue_analysis(pkg)
+                    self.kiskadee_queue.enqueue_analysis(data)
 
-    # Move this to model.py
-    def _save_analyzed_project(self, data):
+    def save_analyzed_project(self, data):
         if not data:
             return {}
         project = self._query(Package).filter_by(name = data['name']).first()
         if not project:
-            project = self._save_project(data)
+            project = Package.save(self.session, data)
         if project:
-            project = self._update_project(project, data)
+            project = Package.update(self.session, project, data)
 
         for analyzer, result in data['results'].items():
-            self._save_analysis(data, analyzer, result, project.versions[-1])
-
-    # Move this to model.py
-    def _update_project(self, package, pkg):
-
-        if(package.versions[-1].number == pkg['version']):
-            return package
-        try:
-            _new_version = Version(
-                    number=pkg['version'],
-                    package_id=package.id
-                    )
-            package.versions.append(_new_version)
-            self.session.add(package)
-            self.session.commit()
-            kiskadee.logger.debug(
-                    "MONITOR: Sending package {}_{}"
-                    "for analysis".format(pkg['name'], pkg['version'])
-                    )
-            return package
-        except ValueError:
-            kiskadee.logger.debug("MONITOR: Could not compare versions")
-            return None
-
-    # Move this to model.py
-    def _save_project(self, pkg):
-        homepage = None
-        if ('meta' in pkg) and ('homepage' in pkg['meta']):
-            homepage = pkg['meta']['homepage']
-
-        _package = Package(
-                name=pkg['name'],
-                homepage=homepage,
-                fetcher_id=pkg['fetcher_id']
-                )
-        self.session.add(_package)
-        self.session.commit()
-        _version = Version(number=pkg['version'],
-                           package_id=_package.id)
-        self.session.add(_version)
-        self.session.commit()
-        return _package
-
-    # Move this to model.py
-    def _save_reports(self, analysis, pkg, analyzer_name):
-        try:
-            results = analysis['results']
-            analyzer_report = REPORTERS[analyzer_name](results)
-            _reports = Report()
-            _reports.results = json.dumps(
-                    analyzer_report
-                    ._compute_reports(analyzer_name)
-                )
-            _reports.analysis_id = analysis['id']
-            self.session.add(_reports)
-            self.session.commit()
-            kiskadee.logger.debug(
-                    "MONITOR: Saved analysis reports for {} package"
-                    .format(pkg["name"])
-                )
-        except KeyError as key:
-            kiskadee.logger.debug(
-                    "ERROR: There's no reporter " +
-                    "to get reports from {} analyzer. ".format(key) +
-                    "Make shure to import or implement them."
-                )
-        except Exception as err:
-            kiskadee.logger.debug(
-                    "MONITOR: Failed to get analysis reports to {} package"
-                    .format(pkg["name"])
-                )
-            kiskadee.logger.debug(err)
-        return
-
-    # Move this to model.py
-    def _save_analysis(self, pkg, analyzer, result, version):
-        _analysis = kiskadee.model.Analysis()
-        try:
-            _analyzer = self._query(kiskadee.model.Analyzer).\
-                    filter_by(name = analyzer).first()
-            _analysis.analyzer_id = _analyzer.id
-            _analysis.version_id = version.id
-            _analysis.raw = json.loads(result)
-            self.session.add(_analysis)
-            self.session.commit()
-            dict_analysis = {
-                    'results': _analysis.raw['results'],
-                    'id': _analysis.id
-                }
-            self._save_reports(dict_analysis, pkg, _analyzer.name)
-            kiskadee.logger.debug(
-                    "MONITOR: Saved analysis done by {} for package: {}-{}"
-                    .format(analyzer, pkg["name"], pkg["version"])
-                )
-            return
-        except Exception as err:
-            kiskadee.logger.debug(
-                    "MONITOR: The required analyzer was " +
-                    "not registered in kiskadee"
-                )
-            kiskadee.logger.debug(err)
-            return None
-
-    # Move this to model.py
-    def _save_fetcher(self, fetcher):
-        name = fetcher.name
-        kiskadee.logger.debug(
-                "MONITOR: Saving {} fetcher in database".format(name)
-            )
-        if not self.session.query(Fetcher)\
-                .filter(Fetcher.name == name).first():
-            _fetcher = Fetcher(
-                    name=name,
-                    target=fetcher.config['target'],
-                    description=fetcher.config['description']
-                )
-            self.session.add(_fetcher)
-            self.session.commit()
+            Analysis.save(self.session, data, analyzer, result, project.versions[-1])
 
     def _query(self, arg):
         return self.session.query(arg)
diff --git a/kiskadee/queue.py b/kiskadee/queue.py
index 214b631..959be72 100644
--- a/kiskadee/queue.py
+++ b/kiskadee/queue.py
@@ -1,6 +1,5 @@
 """Provide kiskadee queues and operations on them."""
 import time
-import dill
 from multiprocessing import Queue
 
 import kiskadee
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index 5f7e764..8fd8de7 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -30,7 +30,7 @@ class Runner:
         kiskadee.logger.debug('Starting runner subprocess')
         kiskadee.logger.debug('runner PID: {}'.format(os.getpid()))
         session = kiskadee.database.Database().session
-        kiskadee.model.create_analyzers(session)
+        kiskadee.model.Analyzer.create_analyzers(session)
         self.queues = queues
         while RUNNING:
             kiskadee.logger.debug('RUNNER: Waiting to dequeue'\
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index 67cd7c2..6d64edf 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -4,7 +4,7 @@ from sqlalchemy.orm import sessionmaker
 from kiskadee import model
 from kiskadee.monitor import Monitor
 from kiskadee.queue import Queues
-from kiskadee.model import Package, create_analyzers, Report, Analysis
+from kiskadee.model import Package, Analyzer, Report, Analysis
 import kiskadee.queue
 import kiskadee.fetchers.debian
 import kiskadee.fetchers.anitya
@@ -20,7 +20,7 @@ class MonitorTestCase(unittest.TestCase):
         self.monitor = Monitor(self.session)
         self.queues = Queues()
         model.Base.metadata.create_all(self.engine)
-        create_analyzers(self.session)
+        Analyzer.create_analyzers(self.session)
         self.pkg1 = {
                 'name': 'curl',
                 'version': '7.52.1-5',
@@ -81,8 +81,8 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_save_package(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor._save_analyzed_project(self.pkg1)
-        self.monitor._save_analyzed_project(self.pkg2)
+        self.monitor.save_analyzed_project(self.pkg1)
+        self.monitor.save_analyzed_project(self.pkg2)
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 2)
         self.assertEqual(_pkgs[0].name, self.pkg1['name'])
@@ -126,7 +126,7 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_save_version(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor._save_analyzed_project(self.pkg1)
+        self.monitor.save_analyzed_project(self.pkg1)
         _pkgs = self.monitor.session.query(Package).all()
         _version = _pkgs[0].versions[0].number
         self.assertEqual(_version, self.pkg1['version'])
@@ -137,10 +137,10 @@ class MonitorTestCase(unittest.TestCase):
         self.queues.enqueue_project(self.pkg3)
 
         _pkg = self.queues.dequeue_project()
-        self.monitor._save_analyzed_project(_pkg)
+        self.monitor.save_analyzed_project(_pkg)
 
         _pkg = self.queues.dequeue_project()
-        self.monitor._save_analyzed_project(_pkg)
+        self.monitor.save_analyzed_project(_pkg)
 
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 1)
@@ -157,7 +157,7 @@ class MonitorTestCase(unittest.TestCase):
         self.monitor._save_fetcher(kiskadee.fetchers.anitya.Fetcher())
         self.queues.enqueue_project(self.pkg4)
         _pkg = self.queues.dequeue_project()
-        self.monitor._save_analyzed_project(_pkg)
+        self.monitor.save_analyzed_project(_pkg)
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 1)
         self.assertEqual(_pkgs[0].homepage, _pkg['meta']['homepage'])
diff --git a/kiskadee/tests/integration/test_runner.py b/kiskadee/tests/integration/test_runner.py
index f9a2e16..d2f08df 100644
--- a/kiskadee/tests/integration/test_runner.py
+++ b/kiskadee/tests/integration/test_runner.py
@@ -21,7 +21,7 @@ class AnalyzersTestCase(unittest.TestCase):
         Session = sessionmaker(bind=self.engine)
         self.session = Session()
         model.Base.metadata.create_all(self.engine)
-        model.create_analyzers(self.session)
+        model.Analyzer.create_analyzers(self.session)
         self.fetcher = kiskadee.fetchers.debian.Fetcher()
         self.deb_pkg = {'name': 'test',
                         'version': '1.0.0',
diff --git a/kiskadee/tests/units/test_model.py b/kiskadee/tests/units/test_model.py
index 4a56835..aba56e7 100644
--- a/kiskadee/tests/units/test_model.py
+++ b/kiskadee/tests/units/test_model.py
@@ -13,7 +13,7 @@ class ModelTestCase(unittest.TestCase):
         Session = sessionmaker(bind=self.engine)
         self.session = Session()
         model.Base.metadata.create_all(self.engine)
-        model.create_analyzers(self.session)
+        model.Analyzer.create_analyzers(self.session)
         self.fetcher = model.Fetcher(
               name='kiskadee-fetcher', target='university'
             )

